#include "Enemigo.h"

Enemigo::Enemigo(Gosu::Graphics& graphics, int movX_min, int movX_max, int movY, int width, int height, int velX )
{
   movX1_ = movX_min;
   movX2_ = movX_max;
   movY_ = movY;
   width_ = width;
   height_ = height;
	pos_ = movX_min;
	dir_ = 0;
   der_ = izq_ = 0;
   velX_ = velX;
   
   control_der_.second = 0;
   control_izq_.second = 0;
}

Enemigo::~Enemigo()
{

}

int Enemigo::movX1()
{
   return movX1_;
}
   
int Enemigo::movX2()
{
   return movX2_;
}

int Enemigo::movY()
{
   return movY_;
}

int Enemigo::width()
{
   return width_;
}

int Enemigo::height()
{
   return height_;
}


int Enemigo::posicion()
{
   return pos_;
}

void Enemigo::posicion(int pos)
{
   pos_ += pos;
}

int Enemigo::direccion()
{
   return dir_;
}

void Enemigo::direccion(int dir)
{
   dir_ = dir;
}

int Enemigo::palader()
{
   der_ = (der_+1) % 2;
   return der_;
}

int Enemigo::palaizq()
{
   izq_ = (izq_+1) % 2;
   return izq_;
}

int Enemigo::velX()
{
   return velX_;
}


pair<vector<Gosu::Image*>,int> Enemigo::control_der() const
{
	return control_der_;
}

pair<vector<Gosu::Image*>,int> Enemigo::control_izq() const
{
	return control_izq_;
}

pair<vector<Gosu::Image*>,int>& Enemigo::control_der()
{
	return control_der_;
}

pair<vector<Gosu::Image*>,int>& Enemigo::control_izq()
{
	return control_izq_;
}


Abeja::Abeja(Gosu::Graphics& graphics, int movX_min, int movX_max, int movY) : Enemigo (graphics, movX_min, movX_max, movY, 50, 60, VELOCIDAD_ABEJA)
{
	control_der_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/1/abeja_3.png"));
	control_der_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/1/abeja_4.png"));
	control_izq_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/1/abeja_1.png"));
	control_izq_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/1/abeja_2.png"));
	control_der_.second = 1;
	control_izq_.second = 1;
}

Mosca::Mosca(Gosu::Graphics& graphics, int movX_min, int movX_max, int movY) : Enemigo (graphics, movX_min, movX_max, movY, 50, 60, VELOCIDAD_MOSCA)
{
	control_der_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/2/mosca3.png"));
	control_der_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/2/mosca4.png"));
	control_izq_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/2/mosca1.png"));
	control_izq_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/2/mosca2.png"));
	control_der_.second = 1;
	control_izq_.second = 1;
}

Cucaracha::Cucaracha(Gosu::Graphics& graphics, int movX_min, int movX_max, int movY) : Enemigo (graphics, movX_min, movX_max, movY, 110, 50, VELOCIDAD_CUCARACHA)
{
	control_der_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/2/cucaracha3.png"));
	control_der_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/2/cucaracha4.png"));
	control_izq_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/2/cucaracha1.png"));
	control_izq_.first.push_back(new Gosu::Image(graphics, L"../graficos/niveles/2/cucaracha2.png"));
	control_der_.second = 1;
	control_izq_.second = 1;
}
